<template>
  <v-row justify="center">
    <v-dialog
      v-model="rolesCreate"
      @keydown.esc="handleClose"
      @click:outside="handleClose"
      width="90%"
    >
      <v-card>
        <v-toolbar style="position:relative" color="white" elevation="0">
          <v-spacer />
          <v-toolbar-title class="mt-5">
            <span class="primary--text">
              <v-icon large color="primary" class="mr-2 pb-1">mdi-bookmark</v-icon><b>Novo Papel</b>
            </span>
          </v-toolbar-title>
          <v-spacer />
          <v-tooltip color="red" bottom>
            <template v-slot:activator="{ on }">
              <v-icon
                v-on="on"
                style="position:absolute; right: 15px"
                color="red"
                @click="handleClose"
                >mdi-close</v-icon
              >
            </template>
            <span><b>Fechar</b> janela</span>
          </v-tooltip>
        </v-toolbar>
        <v-card-text style="max-width: 99% !important;" class="scrollForm">
          <v-form ref="form" v-model="valid">
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    autofocus
                    v-model="role.label"
                    label="Nome*"
                    required
                    prepend-icon="mdi-pencil-box-outline"
                  ></v-text-field>
                </v-col>
                <v-col v-for="(module, index) in entityModules" :key="index" cols="12">
                  <v-row class="roleTitle" >
                    <h2 class="primary--text h2Role">{{ module.label }}</h2>
                    <v-checkbox
                      :id="module.id"
                      v-model="markAllCheck"
                      :value="module.id"
                      class="markAllCheckBox"
                      label="Marcar Todos"
                      color="primary"
                      hide-details
                      @change="checkMarkAll(module.id)"
                    />
                  </v-row>
                  <v-divider class="mt-4" />
                  <v-row>
                    <v-col
                      v-for="(action, actionIndex) in entityModules[index].actions"
                      :key="actionIndex"
                      lg="2"
                      md="3"
                      sm="4"
                      xs="12"
                    >
                      <v-checkbox
                        :id="action.id"
                        :key="action.id"
                        v-model="role.actions"
                        :label="action.label"
                        :value="action.id"
                        color="primary"
                        hide-details
                      />
                    </v-col>
                  </v-row>
                  <v-divider />
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card-text>
        <v-card-actions class="mt-n3 pb-6 pr-6">
          <v-spacer />
          <v-btn color="lighter" text @click="handleClose">Cancelar</v-btn>
          <v-btn color="primary" @click="handleCreate" elevation="0" :disabled="!role.label"
            >Adicionar</v-btn
          >
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<script>
import { mapMutations, mapState } from 'vuex'
import Management from '../../services/management'
import User from '../../services/user'

export default {
  name: 'RolesCreate',
  components: {},
  data: () => ({
    markAllCheck: [],
    selected: { option0: false, option1: false, option2: false, option3: false },
    role: {
      label: '',
      actions: [],
    },
    valid: false,
  }),

  computed: {
    ...mapState('user', ['rolesCreate', 'entityModules']),
  },
  methods: {
    ...mapMutations('user', ['UPDATE_ROLES_CREATE', 'UPDATE_LOADING', 'ADD_COURSE']),
    handleClose() {
      this.$refs.form.reset()
      this.UPDATE_ROLES_CREATE(false)
    },
    async handleCreate() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('createPrivilege').id
      try {
        this.UPDATE_LOADING(true)
        let ret = await Management.createPrivilege(entityId, actionId, this.role)
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.handleClose()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Papel <b>criado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
      } catch (e) {
        console.log('catch create role', e)
      } finally {
        this.UPDATE_LOADING(false)
      }
      this.$parent.readRoles()
    },

    checkMarkAll(id) {
      let array = []
      let entity = this.compare(id)
      for (let q = 0; q < this.entityModules.length; q++) {
        if (entity.id == q) {
          this.selected[`${entity.idString}`] = !this.selected[`${entity.idString}`]

          if (this.selected[`${entity.idString}`]) {
            this.entityModules[entity.id].actions.forEach((field, index) => {
              if (
                this.role.actions.indexOf(this.entityModules[entity.id].actions[index].id) === -1
              ) {
                this.role.actions.push(field.id)
              }
            })
          } else {
            for (let i = 0; i < this.role.actions.length; i++) {
              let same = 0
              let check = 0
              for (let x = 0; x < this.entityModules[entity.id].actions.length; x++) {
                if (this.role.actions[i] === this.entityModules[entity.id].actions[x].id) {
                  same++
                  check++
                } else {
                  check++
                  if (same == 0 && check == this.entityModules[entity.id].actions.length) {
                    array.push(this.role.actions[i])
                  }
                }
              }
            }
            this.role = Object.assign(this.role, { actions: array })
          }
        }
      }
    },

    compare(id) {
      let entityId = null
      let idString = null
      for (let x = 0; x < this.entityModules.length; x++) {
        if (id === this.entityModules[x].id) {
          entityId = x
        }
      }
      return { id: entityId, idString: `option${entityId}` }
    },
  },
}
</script>

<style scoped>

.roleTitle {
  position: relative;
  display: flex;
  justify-content: center;
  align-items: center;
  padding-top: 10px;
  padding-bottom: 15px;
}
  .h2Role{
    position: absolute;
    margin: 0;
  }
  .markAllCheckBox{
    position: absolute; 
    right:0; 
    padding: 0; 
    margin: 0;
  }

@media (max-width: 600px) {
    .h2Role{
      margin-left: 10px;
    }
    .roleTitle{
      position: relative;
      display: flex;
      justify-content: start;
      align-items: center;
    }
  }
  
</style>
